using System;
using System.Drawing;
using System.Windows.Forms;
using Plux;
using Plux.Framework;

[Extension("MetrixFigures", OnCreated = "OnCreated")]
[Plug("Metrix.View")]
[Slot("Plux.Figure", Multiple = true, LazyLoad=true)]
[ParamValue("Name", "Figures")]
[ReplaceSlot("Plux.Figure", Plug=true)]
public class Figures : IView {
  readonly PlugCheckedListBox ctl = new PlugCheckedListBox();
  public Figures() {
    ctl.FormattingEnabled = true;
    ctl.IntegralHeight = false;
    ctl.Font = new Font("Tahoma", 9F, FontStyle.Regular, GraphicsUnit.Point, 0);
    ctl.Format += FormatText;
    ctl.HorizontalScrollbar = true;
    ctl.CheckOnClick = true;
  }
  #region IView Members
  public string Name {
    get {
      PlugInfo view = Runtime.GetPlugInfo(this, "Metrix.View");
      return (string) view.PlugTypeInfo.GetParamValue("Name");
    }
  }
  public Control Control {
    get { return ctl; }
  }
  #endregion
  public void OnCreated(object s, ExtensionEventArgs args) {
    ctl.Attach(Runtime.GetSlotInfo(this, "Plux.Figure"));
  }
 public void FormatText(object sender, ListControlConvertEventArgs e) {
   PlugTypeInfo plugType = (PlugTypeInfo) e.ListItem;
   e.Value = String.Format(
      "{0} ({1})",
      plugType.GetParamValue("Description"),
      plugType.GetParamValue("Scope"));
  }
}