﻿using System;
using System.Collections;
using System.Windows.Forms;
using Plux;


public partial class SearchControl : UserControl {
  public SearchControl() {
    InitializeComponent();
  }

  private IEnumerable items;
  public IEnumerable Items {
    get { return items; }
    set {
      items = value;
      if (items != null) {
        foreach (var o in Items) {
          result.Items.Add(o);
        }
      }
    }
  }

  private void filter_TextChanged(object sender, EventArgs e) {
    result.Items.Clear();
    foreach (var s in Items) {
      var text = format(s);
      if (text.IndexOf(filter.Text, StringComparison.OrdinalIgnoreCase) > -1) {
        result.Items.Add(s);
      }
      if (result.Items.Count > 0) {
        result.SelectedIndex = 0;
      }
    }
  }


  public delegate string FormatDelegate(object o);


  private void FormatPlug(object sender, ListControlConvertEventArgs e) {
    e.Value = format(e.ListItem);
  }

  public FormatDelegate Format {
    set {
      format = value;
      result.Format += FormatPlug;
      result.FormattingEnabled = true;
    }
  }

  private FormatDelegate format;

  protected override bool ProcessCmdKey(ref Message msg, Keys keyData) {
    if (keyData != Keys.Escape && keyData != Keys.Enter) {
      if (filter.Focused) {
        if (keyData == Keys.Down || keyData == Keys.Up) {
          result.Focus();
          SendKeys.Send(keyData.ToString());
          return true;
        }
      } else if (result.Focused) {}
    }
    return base.ProcessCmdKey(ref msg, keyData);
  }
}